# -*- coding: utf-8 -*-
"""
Created on Fri Nov  8 14:29:03 2024

@author: mstep
"""

def get_permutations(values, permutations, is_used, current_permutation):
    '''
    Find the permutations of the values.
    Add any permutations found to the permutations list.
    '''
    # See if we have a full permutation.
    if len(current_permutation) == len(values):
        # All items are in the current permutation so it's full.
        permutations.append(current_permutation.copy())
    else:
        # The current permutation isn't full.
        # Search for an unused value.
        for i in range(len(values)):
            if not is_used[i]:
                # This value isn't currently in use.
                # Add it to the current permutation.
                current_permutation.append(values[i])
                is_used[i] = True

                get_permutations(values, permutations, is_used, current_permutation)

                # Remove the value from the current permutation.
                current_permutation.pop()
                is_used[i] = False

# Main prorgam.
values = ['A', 'B', 'C']

# Use itertools.
import itertools

for permutation in itertools.permutations(values):
    print(permutation)
print('***************')

# Find the permutations ourselves.
is_used = [False for _ in values]
permutations = []
current_permutation = []
get_permutations(values, permutations, is_used, current_permutation)

for permutation in permutations:
    print(permutation)
